import * as i0 from '@angular/core';
import { Component, HostBinding, NgModule, CUSTOM_ELEMENTS_SCHEMA, forwardRef, Inject, ContentChildren, EventEmitter, ViewEncapsulation, Input, Output, ContentChild, HostListener } from '@angular/core';
import { CommonModule } from '@angular/common';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatButton } from '@angular/material/button';

class PipActionListComponent {
    constructor() {
        this.klass = true;
    }
}
PipActionListComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipActionListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
PipActionListComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: PipActionListComponent, selector: "pip-action-list", host: { properties: { "class.pip-action-list": "this.klass" } }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, styles: [":host{display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;align-items:center;justify-content:center}:host ::ng-deep .pip-action-list-item{min-height:64px!important;min-width:64px!important;max-width:92px!important;margin-right:8px;color:#999!important;white-space:normal}:host ::ng-deep .pip-action-list-item .mat-button-wrapper{display:flex;-webkit-box-flex-direction:column;-moz-box-flex-direction:column;flex-direction:column;align-items:center;justify-content:center}:host ::ng-deep .pip-action-list-item .mat-button-wrapper .mat-icon{width:32px;height:32px;font-size:32px}:host ::ng-deep .pip-action-list-item .pip-title{line-height:1em;margin-top:8px;margin-bottom:4px;font-size:14px;overflow:hidden;white-space:normal;word-wrap:break-word;vertical-align:middle;font:normal 400 12px;text-align:center;-webkit-user-select:auto}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipActionListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'pip-action-list', template: '<ng-content></ng-content>', styles: [":host{display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;align-items:center;justify-content:center}:host ::ng-deep .pip-action-list-item{min-height:64px!important;min-width:64px!important;max-width:92px!important;margin-right:8px;color:#999!important;white-space:normal}:host ::ng-deep .pip-action-list-item .mat-button-wrapper{display:flex;-webkit-box-flex-direction:column;-moz-box-flex-direction:column;flex-direction:column;align-items:center;justify-content:center}:host ::ng-deep .pip-action-list-item .mat-button-wrapper .mat-icon{width:32px;height:32px;font-size:32px}:host ::ng-deep .pip-action-list-item .pip-title{line-height:1em;margin-top:8px;margin-bottom:4px;font-size:14px;overflow:hidden;white-space:normal;word-wrap:break-word;vertical-align:middle;font:normal 400 12px;text-align:center;-webkit-user-select:auto}\n"] }]
        }], propDecorators: { klass: [{
                type: HostBinding,
                args: ['class.pip-action-list']
            }] } });

class PipActionListModule {
}
PipActionListModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipActionListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
PipActionListModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: PipActionListModule, declarations: [PipActionListComponent], imports: [CommonModule], exports: [PipActionListComponent] });
PipActionListModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipActionListModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipActionListModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    exports: [PipActionListComponent],
                    declarations: [PipActionListComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }] });

class PipButtonToggleGroupComponent {
    constructor() {
        this.klass = true;
    }
}
PipButtonToggleGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipButtonToggleGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
PipButtonToggleGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: PipButtonToggleGroupComponent, selector: "pip-button-toggle-group", host: { properties: { "class.pip-button-toggle-group": "this.klass" } }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, styles: [":host{box-sizing:border-box}:host ::ng-deep mat-button-toggle-group{width:100%;display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;box-shadow:none!important}:host ::ng-deep mat-button-toggle-group mat-button-toggle{text-align:center;flex:1 1 100%;box-sizing:border-box;border:none!important;margin-left:2px;margin-right:2px}:host ::ng-deep mat-button-toggle-group mat-button-toggle:first-of-type{margin-left:0;border-top-left-radius:4px;border-bottom-left-radius:4px}:host ::ng-deep mat-button-toggle-group mat-button-toggle:last-of-type{margin-right:0;border-top-right-radius:4px;border-bottom-right-radius:4px}:host ::ng-deep mat-button-toggle-group mat-button-toggle .mat-button-toggle-label-content{padding:0;width:100%}:host ::ng-deep mat-button-toggle-group mat-button-toggle .mat-button-toggle-focus-overlay{display:none}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group{-webkit-box-flex-direction:column!important;-moz-box-flex-direction:column!important;flex-direction:column!important}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group mat-button-toggle,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group mat-button-toggle{margin:2px 0;border-radius:0}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group mat-button-toggle:first-of-type,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group mat-button-toggle:first-of-type{margin-top:0;border-top-left-radius:4px;border-top-right-radius:4px}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group mat-button-toggle:last-of-type,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group mat-button-toggle:last-of-type{margin-bottom:0;border-bottom-left-radius:4px;border-bottom-right-radius:4px}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipButtonToggleGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'pip-button-toggle-group', template: '<ng-content></ng-content>', styles: [":host{box-sizing:border-box}:host ::ng-deep mat-button-toggle-group{width:100%;display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;box-shadow:none!important}:host ::ng-deep mat-button-toggle-group mat-button-toggle{text-align:center;flex:1 1 100%;box-sizing:border-box;border:none!important;margin-left:2px;margin-right:2px}:host ::ng-deep mat-button-toggle-group mat-button-toggle:first-of-type{margin-left:0;border-top-left-radius:4px;border-bottom-left-radius:4px}:host ::ng-deep mat-button-toggle-group mat-button-toggle:last-of-type{margin-right:0;border-top-right-radius:4px;border-bottom-right-radius:4px}:host ::ng-deep mat-button-toggle-group mat-button-toggle .mat-button-toggle-label-content{padding:0;width:100%}:host ::ng-deep mat-button-toggle-group mat-button-toggle .mat-button-toggle-focus-overlay{display:none}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group{-webkit-box-flex-direction:column!important;-moz-box-flex-direction:column!important;flex-direction:column!important}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group mat-button-toggle,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group mat-button-toggle{margin:2px 0;border-radius:0}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group mat-button-toggle:first-of-type,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group mat-button-toggle:first-of-type{margin-top:0;border-top-left-radius:4px;border-top-right-radius:4px}::ng-deep .pip-main-xs pip-button-toggle-group mat-button-toggle-group mat-button-toggle:last-of-type,::ng-deep .pip-main-sm pip-button-toggle-group mat-button-toggle-group mat-button-toggle:last-of-type{margin-bottom:0;border-bottom-left-radius:4px;border-bottom-right-radius:4px}\n"] }]
        }], propDecorators: { klass: [{
                type: HostBinding,
                args: ['class.pip-button-toggle-group']
            }] } });

class PipButtonToggleGroupModule {
}
PipButtonToggleGroupModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipButtonToggleGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
PipButtonToggleGroupModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: PipButtonToggleGroupModule, declarations: [PipButtonToggleGroupComponent], imports: [CommonModule, MatButtonToggleModule], exports: [PipButtonToggleGroupComponent] });
PipButtonToggleGroupModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipButtonToggleGroupModule, imports: [CommonModule, MatButtonToggleModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipButtonToggleGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, MatButtonToggleModule],
                    declarations: [PipButtonToggleGroupComponent],
                    exports: [PipButtonToggleGroupComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }] });

class PipDrilldownListComponent {
    constructor() {
        this.klass = true;
    }
}
PipDrilldownListComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipDrilldownListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
PipDrilldownListComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: PipDrilldownListComponent, selector: "pip-drilldown-list", host: { properties: { "class.pip-drilldown-list": "this.klass" } }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, styles: [":host ::ng-deep .pip-drilldown-list-item{opacity:.54;height:48px;width:100%;margin:0!important;padding-left:24px;padding-right:16px;border-radius:0!important;display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;align-items:center;justify-content:flex-start;text-transform:none!important;font: 500 16px Roboto}:host ::ng-deep .pip-drilldown-list-item mat-icon{flex:0 0 auto;min-width:24px}:host ::ng-deep .pip-drilldown-list-item .mat-button-wrapper{width:100%}:host ::ng-deep .pip-drilldown-list-item .pip-content{display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;align-items:center;width:100%}:host ::ng-deep .pip-drilldown-list-item.pip-selected{padding-left:19px;background-color:#9e9e9e33;border-left:5px solid rgba(33,150,243,.5)!important}:host ::ng-deep .pip-drilldown-list-item .pip-title{text-align:start;display:flex;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;margin:0 16px 0 0;height:25px;flex:1;-webkit-flex:1;-ms-flex:1;box-sizing:border-box}:host ::ng-deep .pip-drilldown-list-item .pip-subtitle{font: 400 14px Roboto;opacity:.54;text-align:start;margin:0 24px 0 0;overflow:hidden;text-overflow:ellipsis}:host ::ng-deep .pip-drilldown-list-item .pip-icon{margin-right:26px}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg{height:64px}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg .pip-title{margin-top:1px!important;margin-bottom:4px!important}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg .pip-subcontent{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;flex:1;box-sizing:border-box}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg .pip-subcontent .pip-title{height:initial}::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item,::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item{padding-left:16px;padding-right:10px}::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item.pip-selected,::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item.pip-selected{padding-left:11px}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipDrilldownListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'pip-drilldown-list', template: '<ng-content></ng-content>', styles: [":host ::ng-deep .pip-drilldown-list-item{opacity:.54;height:48px;width:100%;margin:0!important;padding-left:24px;padding-right:16px;border-radius:0!important;display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;align-items:center;justify-content:flex-start;text-transform:none!important;font: 500 16px Roboto}:host ::ng-deep .pip-drilldown-list-item mat-icon{flex:0 0 auto;min-width:24px}:host ::ng-deep .pip-drilldown-list-item .mat-button-wrapper{width:100%}:host ::ng-deep .pip-drilldown-list-item .pip-content{display:flex;-webkit-box-flex-direction:row;-moz-box-flex-direction:row;flex-direction:row;align-items:center;width:100%}:host ::ng-deep .pip-drilldown-list-item.pip-selected{padding-left:19px;background-color:#9e9e9e33;border-left:5px solid rgba(33,150,243,.5)!important}:host ::ng-deep .pip-drilldown-list-item .pip-title{text-align:start;display:flex;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;margin:0 16px 0 0;height:25px;flex:1;-webkit-flex:1;-ms-flex:1;box-sizing:border-box}:host ::ng-deep .pip-drilldown-list-item .pip-subtitle{font: 400 14px Roboto;opacity:.54;text-align:start;margin:0 24px 0 0;overflow:hidden;text-overflow:ellipsis}:host ::ng-deep .pip-drilldown-list-item .pip-icon{margin-right:26px}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg{height:64px}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg .pip-title{margin-top:1px!important;margin-bottom:4px!important}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg .pip-subcontent{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;flex:1;box-sizing:border-box}:host ::ng-deep .pip-drilldown-list-item.pip-drilldown-list-item-lg .pip-subcontent .pip-title{height:initial}::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item,::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item{padding-left:16px;padding-right:10px}::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item.pip-selected,::ng-deep .pip-main-xs .pip-main .pip-drilldown-list-item.pip-selected{padding-left:11px}\n"] }]
        }], propDecorators: { klass: [{
                type: HostBinding,
                args: ['class.pip-drilldown-list']
            }] } });

class PipDrilldownListModule {
}
PipDrilldownListModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipDrilldownListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
PipDrilldownListModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: PipDrilldownListModule, declarations: [PipDrilldownListComponent], imports: [CommonModule], exports: [PipDrilldownListComponent] });
PipDrilldownListModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipDrilldownListModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipDrilldownListModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [PipDrilldownListComponent],
                    exports: [PipDrilldownListComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }] });

const Z_INDEX_ITEM = 23;
class PipFabSpeedDialActionsComponent {
    constructor(_parent, renderer) {
        this._parent = _parent;
        this.renderer = renderer;
    }
    ngAfterContentInit() {
        this._buttons.changes.subscribe(() => {
            this.initButtonStates();
            this._parent.setActionsVisibility();
        });
        this.initButtonStates();
    }
    initButtonStates() {
        this._buttons.toArray().forEach((button, i) => {
            this.renderer.addClass(button._getHostElement(), 'pip-fab-action-item');
            this.changeElementStyle(button._getHostElement(), 'z-index', '' + (Z_INDEX_ITEM - i));
        });
    }
    show() {
        if (this._buttons) {
            this._buttons.toArray().forEach((button, i) => {
                let transitionDelay = 0;
                let transform;
                if (this._parent.animationMode === 'scale') {
                    // Incremental transition delay of 65ms for each action button
                    transitionDelay = 3 + 65 * i;
                    transform = 'scale(1)';
                }
                else {
                    transform = this.getTranslateFunction('0');
                }
                this.changeElementStyle(button._getHostElement(), 'transition-delay', transitionDelay + 'ms');
                this.changeElementStyle(button._getHostElement(), 'opacity', '1');
                this.changeElementStyle(button._getHostElement(), 'transform', transform);
            });
        }
    }
    hide() {
        if (this._buttons) {
            this._buttons.toArray().forEach((button, i) => {
                let opacity = '1';
                let transitionDelay = 0;
                let transform;
                if (this._parent.animationMode === 'scale') {
                    transitionDelay = 3 - 65 * i;
                    transform = 'scale(0)';
                    opacity = '0';
                }
                else {
                    transform = this.getTranslateFunction(55 * (i + 1) - i * 5 + 'px');
                }
                this.changeElementStyle(button._getHostElement(), 'transition-delay', transitionDelay + 'ms');
                this.changeElementStyle(button._getHostElement(), 'opacity', opacity);
                this.changeElementStyle(button._getHostElement(), 'transform', transform);
            });
        }
    }
    getTranslateFunction(value) {
        const dir = this._parent.direction;
        const translateFn = dir === 'up' || dir === 'down' ? 'translateY' : 'translateX';
        const sign = dir === 'down' || dir === 'right' ? '-' : '';
        return translateFn + '(' + sign + value + ')';
    }
    changeElementStyle(elem, style, value) {
        // FIXME - Find a way to create a "wrapper" around the action button(s) provided by the user, so we don't change it's style tag
        // FIXME - Find a way to create a "wrapper" around the action button(s) provided by the user, so we don't change it's style tag
        this.renderer.setStyle(elem, style, value);
    }
}
PipFabSpeedDialActionsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialActionsComponent, deps: [{ token: forwardRef(() => PipFabSpeedDialComponent) }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
PipFabSpeedDialActionsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: PipFabSpeedDialActionsComponent, selector: "pip-fab-actions", queries: [{ propertyName: "_buttons", predicate: MatButton }], ngImport: i0, template: `<ng-content select="[md-mini-fab], [mat-mini-fab]"></ng-content>`, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialActionsComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'pip-fab-actions',
                    template: `<ng-content select="[md-mini-fab], [mat-mini-fab]"></ng-content>`,
                }]
        }], ctorParameters: function () { return [{ type: PipFabSpeedDialComponent, decorators: [{
                    type: Inject,
                    args: [forwardRef(() => PipFabSpeedDialComponent)]
                }] }, { type: i0.Renderer2 }]; }, propDecorators: { _buttons: [{
                type: ContentChildren,
                args: [MatButton]
            }] } });

class PipFabSpeedDialComponent {
    constructor(elementRef, renderer) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.isInitialized = false;
        this._direction = 'up';
        this._open = false;
        this._animationMode = 'fling';
        /**
         * Whether this speed dial is fixed on screen (user cannot change it by clicking)
         */
        this.fixed = false;
        this.openChange = new EventEmitter();
        this.klass = true;
    }
    /**
     * Whether this speed dial is opened
     */
    get open() {
        return this._open;
    }
    set open(open) {
        const previousOpen = this._open;
        this._open = open;
        if (previousOpen !== this._open) {
            this.openChange.emit(this._open);
            if (this.isInitialized) {
                this.setActionsVisibility();
            }
        }
    }
    /**
     * The direction of the speed dial. Can be 'up', 'down', 'left' or 'right'
     */
    get direction() {
        return this._direction;
    }
    set direction(direction) {
        const previousDir = this._direction;
        this._direction = direction;
        if (previousDir !== this.direction) {
            this._setElementClass(previousDir, false);
            this._setElementClass(this.direction, true);
            if (this.isInitialized) {
                this.setActionsVisibility();
            }
        }
    }
    /**
     * The animation mode to open the speed dial. Can be 'fling' or 'scale'
     */
    get animationMode() {
        return this._animationMode;
    }
    set animationMode(animationMode) {
        const previousAnimationMode = this._animationMode;
        this._animationMode = animationMode;
        if (previousAnimationMode !== this._animationMode) {
            this._setElementClass(previousAnimationMode, false);
            this._setElementClass(this.animationMode, true);
            if (this.isInitialized) {
                // To start another detect lifecycle and force the "close" on the action buttons
                Promise.resolve(null).then(() => (this.open = false));
            }
        }
    }
    ngAfterContentInit() {
        this.isInitialized = true;
        this.setActionsVisibility();
        this._setElementClass(this.direction, true);
        this._setElementClass(this.animationMode, true);
    }
    /**
     * Toggle the open state of this speed dial
     */
    toggle() {
        this.open = !this.open;
    }
    _onClick() {
        if (!this.fixed && this.open) {
            this.open = false;
        }
    }
    setActionsVisibility() {
        if (this.open) {
            this._childActions.show();
        }
        else {
            this._childActions.hide();
        }
    }
    _setElementClass(elemClass, isAdd) {
        isAdd
            ? this.renderer.addClass(this.elementRef.nativeElement, `pip-${elemClass}`)
            : this.renderer.removeClass(this.elementRef.nativeElement, `pip-${elemClass}`);
    }
}
PipFabSpeedDialComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialComponent, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
PipFabSpeedDialComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: PipFabSpeedDialComponent, selector: "pip-fab-speed-dial", inputs: { fixed: "fixed", open: "open", direction: "direction", animationMode: "animationMode" }, outputs: { openChange: "openChange" }, host: { listeners: { "click": "_onClick()" }, properties: { "class.pip-opened": "this.open", "class.pip-fab-speed-dial": "this.klass" } }, queries: [{ propertyName: "_childActions", first: true, predicate: PipFabSpeedDialActionsComponent, descendants: true }], ngImport: i0, template: `
    <div class="pip-fab-speed-dial-container">
      <ng-content select="pip-fab-trigger"></ng-content>
      <ng-content select="pip-fab-actions"></ng-content>
    </div>
  `, isInline: true, styles: ["pip-fab-speed-dial{display:inline-block}pip-fab-speed-dial.pip-opened .pip-fab-speed-dial-container pip-fab-trigger.pip-spin{transform:rotate(360deg)}pip-fab-speed-dial .pip-fab-speed-dial-container{position:relative;display:flex;align-items:center;z-index:20}pip-fab-speed-dial .pip-fab-speed-dial-container pip-fab-trigger{pointer-events:auto;z-index:24}pip-fab-speed-dial .pip-fab-speed-dial-container pip-fab-trigger.pip-spin{transition:all .6s cubic-bezier(.4,0,.2,1)}pip-fab-speed-dial .pip-fab-speed-dial-container pip-fab-actions{display:flex;height:auto}pip-fab-speed-dial.pip-fling .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{display:block;opacity:1;transition:all .3s cubic-bezier(.55,0,.55,.2)}pip-fab-speed-dial.pip-scale .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{transform:scale(0);transition:all .3s cubic-bezier(.55,0,.55,.2);transition-duration:.14286s}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container{flex-direction:column}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container pip-fab-trigger{order:1}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container pip-fab-actions{flex-direction:column;order:2}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-top:10px}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container{flex-direction:column}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container pip-fab-trigger{order:2}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container pip-fab-actions{flex-direction:column-reverse;order:1}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-bottom:10px}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container{flex-direction:row}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container pip-fab-trigger{order:2}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container pip-fab-actions{flex-direction:row-reverse;order:1}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-right:10px}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container{flex-direction:row}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container pip-fab-trigger{order:1}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container pip-fab-actions{flex-direction:row;order:2}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-left:10px}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialComponent, decorators: [{
            type: Component,
            args: [{ selector: 'pip-fab-speed-dial', template: `
    <div class="pip-fab-speed-dial-container">
      <ng-content select="pip-fab-trigger"></ng-content>
      <ng-content select="pip-fab-actions"></ng-content>
    </div>
  `, encapsulation: ViewEncapsulation.None, styles: ["pip-fab-speed-dial{display:inline-block}pip-fab-speed-dial.pip-opened .pip-fab-speed-dial-container pip-fab-trigger.pip-spin{transform:rotate(360deg)}pip-fab-speed-dial .pip-fab-speed-dial-container{position:relative;display:flex;align-items:center;z-index:20}pip-fab-speed-dial .pip-fab-speed-dial-container pip-fab-trigger{pointer-events:auto;z-index:24}pip-fab-speed-dial .pip-fab-speed-dial-container pip-fab-trigger.pip-spin{transition:all .6s cubic-bezier(.4,0,.2,1)}pip-fab-speed-dial .pip-fab-speed-dial-container pip-fab-actions{display:flex;height:auto}pip-fab-speed-dial.pip-fling .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{display:block;opacity:1;transition:all .3s cubic-bezier(.55,0,.55,.2)}pip-fab-speed-dial.pip-scale .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{transform:scale(0);transition:all .3s cubic-bezier(.55,0,.55,.2);transition-duration:.14286s}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container{flex-direction:column}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container pip-fab-trigger{order:1}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container pip-fab-actions{flex-direction:column;order:2}pip-fab-speed-dial.pip-down .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-top:10px}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container{flex-direction:column}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container pip-fab-trigger{order:2}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container pip-fab-actions{flex-direction:column-reverse;order:1}pip-fab-speed-dial.pip-up .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-bottom:10px}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container{flex-direction:row}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container pip-fab-trigger{order:2}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container pip-fab-actions{flex-direction:row-reverse;order:1}pip-fab-speed-dial.pip-left .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-right:10px}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container{flex-direction:row}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container pip-fab-trigger{order:1}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container pip-fab-actions{flex-direction:row;order:2}pip-fab-speed-dial.pip-right .pip-fab-speed-dial-container pip-fab-actions .pip-fab-action-item{margin-left:10px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { fixed: [{
                type: Input
            }], open: [{
                type: HostBinding,
                args: ['class.pip-opened']
            }, {
                type: Input
            }], direction: [{
                type: Input
            }], animationMode: [{
                type: Input
            }], openChange: [{
                type: Output
            }], klass: [{
                type: HostBinding,
                args: ['class.pip-fab-speed-dial']
            }], _childActions: [{
                type: ContentChild,
                args: [PipFabSpeedDialActionsComponent]
            }], _onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class PipFabSpeedDialTriggerComponent {
    constructor(_parent) {
        this._parent = _parent;
        /**
         * Whether this trigger should spin (360dg) while opening the speed dial
         */
        this.spin = false;
    }
    _onClick(event) {
        if (!this._parent.fixed) {
            this._parent.toggle();
            event.stopPropagation();
        }
    }
}
PipFabSpeedDialTriggerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialTriggerComponent, deps: [{ token: forwardRef(() => PipFabSpeedDialComponent) }], target: i0.ɵɵFactoryTarget.Component });
PipFabSpeedDialTriggerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: PipFabSpeedDialTriggerComponent, selector: "pip-fab-trigger", inputs: { spin: "spin" }, host: { listeners: { "click": "_onClick($event)" }, properties: { "class.pip-spin": "this.spin" } }, ngImport: i0, template: `<ng-content select="[md-fab], [mat-fab]"></ng-content>`, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialTriggerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'pip-fab-trigger',
                    template: `<ng-content select="[md-fab], [mat-fab]"></ng-content>`,
                }]
        }], ctorParameters: function () { return [{ type: PipFabSpeedDialComponent, decorators: [{
                    type: Inject,
                    args: [forwardRef(() => PipFabSpeedDialComponent)]
                }] }]; }, propDecorators: { spin: [{
                type: HostBinding,
                args: ['class.pip-spin']
            }, {
                type: Input
            }], _onClick: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

const COMPONENTS = [PipFabSpeedDialComponent, PipFabSpeedDialActionsComponent, PipFabSpeedDialTriggerComponent];
class PipFabSpeedDialModule {
}
PipFabSpeedDialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
PipFabSpeedDialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialModule, declarations: [PipFabSpeedDialComponent, PipFabSpeedDialActionsComponent, PipFabSpeedDialTriggerComponent], imports: [CommonModule], exports: [PipFabSpeedDialComponent, PipFabSpeedDialActionsComponent, PipFabSpeedDialTriggerComponent] });
PipFabSpeedDialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: PipFabSpeedDialModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: COMPONENTS,
                    exports: COMPONENTS,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }] });

/*
 * Public API Surface of pip-webui-buttons-ngx
 */

/**
 * Generated bundle index. Do not edit.
 */

export { PipActionListComponent, PipActionListModule, PipButtonToggleGroupComponent, PipButtonToggleGroupModule, PipDrilldownListComponent, PipDrilldownListModule, PipFabSpeedDialActionsComponent, PipFabSpeedDialComponent, PipFabSpeedDialModule, PipFabSpeedDialTriggerComponent };
//# sourceMappingURL=pip-webui-buttons-ngx.mjs.map
